/*
	ctalk - a curses based geektalk client
	Copyright 2000, Jeff Hunt (heinz@skylab.org)
	License is GPL
*/

#include <fcntl.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>

#include "ctalk.h"
#include "functions.h"

int main(int argc, char *argv[])
{
	int port;
	int sockfd;
	int result;
	char *username, *hostname;

	struct sockaddr_in address;
	struct hostent *hostinfo;
	
	if(argc < 3)
	{
		fprintf(stderr, "ctalk usage: %s [yourname@yourhost] [host] [port number]\n", argv[0]);
		fprintf(stderr, "The [port number] argument is optional, and defaults to 41000 if left out.\n");
		exit(1);
	}
	
	/* Does the host exist? */
	hostinfo = gethostbyname(argv[2]);
	if(!hostinfo)
	{
		fprintf(stderr, "Could not find host \'%s\'\n", argv[2]);
		exit(2);
	}

	/* Check for / supply port number */
	if(!argv[3])
	{
		port = 41000;
	} else port = atoi(argv[3]);

	/* set up the socket */	
	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	address.sin_family = AF_INET;
	address.sin_port = htons(port);
	address.sin_addr = *(struct in_addr *)*hostinfo -> h_addr_list;
		
	result = connect(sockfd, (struct sockaddr *)&address, sizeof(address));
	if(result == -1)
	{
		fprintf(stderr, "Could not connect: Connection Refused.\n");
		exit(3);
	}

	/* figure out user and host name */
	username = strtok(argv[1], "@");
	hostname = strtok(NULL, " ");
	
	logon(username, hostname, sockfd);
	ourserver = argv[2];
	init_curses();
	keithmoon(sockfd);

	exit(0);
}
